OBJS = \
	${BIN_DIR}/database.${OBJ_EXT} \
	${BIN_DIR}/exceptions.${OBJ_EXT} \
	${BIN_DIR}/help.${OBJ_EXT} \
	${BIN_DIR}/log.${OBJ_EXT} \
	${BIN_DIR}/main.${OBJ_EXT} \
	${BIN_DIR}/phase1_file.${OBJ_EXT} \
	${BIN_DIR}/phase1_parser.${OBJ_EXT} \
	${BIN_DIR}/phase1_run.${OBJ_EXT} \
	${BIN_DIR}/phase1_scanner.${OBJ_EXT} \
	${BIN_DIR}/phase1_scanner_doc.${OBJ_EXT} \
	${BIN_DIR}/phase2.${OBJ_EXT} \
	${BIN_DIR}/phase3.${OBJ_EXT} \
	${BIN_DIR}/phase3_html.${OBJ_EXT} \
	${BIN_DIR}/statement.${OBJ_EXT} \
	${BIN_DIR}/strmgr.${OBJ_EXT} \
	${BIN_DIR}/switches.${OBJ_EXT}

${BIN_DIR}/database.${OBJ_EXT} : database.cc \
	database.h \
	exceptions.h \
	log.h \
	statement.h \
	strmgr.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ database.cc

${BIN_DIR}/exceptions.${OBJ_EXT} : exceptions.cc \
	exceptions.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ exceptions.cc

${BIN_DIR}/help.${OBJ_EXT} : help.cc \
	exceptions.h \
	log.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ help.cc

${BIN_DIR}/log.${OBJ_EXT} : log.cc \
	exceptions.h \
	log.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ log.cc

${BIN_DIR}/main.${OBJ_EXT} : main.cc \
	database.h \
	exceptions.h \
	log.h \
	phase1.h \
	phase2.h \
	phase3.h \
	statement.h \
	strmgr.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ main.cc

${BIN_DIR}/phase1_file.${OBJ_EXT} : phase1_file.cc \
	database.h \
	exceptions.h \
	log.h \
	phase1_file.h \
	phase1_parser.h \
	phase1_scanner.h \
	statement.h \
	strmgr.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ phase1_file.cc

${BIN_DIR}/phase1_parser.${OBJ_EXT} : phase1_parser.cc \
	database.h \
	exceptions.h \
	log.h \
	phase1_parser.h \
	phase1_scanner.h \
	statement.h \
	strmgr.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ phase1_parser.cc

${BIN_DIR}/phase1_run.${OBJ_EXT} : phase1_run.cc \
	database.h \
	exceptions.h \
	log.h \
	phase1.h \
	phase1_file.h \
	statement.h \
	strmgr.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ phase1_run.cc

${BIN_DIR}/phase1_scanner.${OBJ_EXT} : phase1_scanner.cc \
	exceptions.h \
	log.h \
	phase1_scanner.h \
	statement.h \
	strmgr.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ phase1_scanner.cc

${BIN_DIR}/phase1_scanner_doc.${OBJ_EXT} : phase1_scanner_doc.cc \
	exceptions.h \
	log.h \
	phase1_scanner.h \
	statement.h \
	strmgr.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ phase1_scanner_doc.cc

${BIN_DIR}/phase2.${OBJ_EXT} : phase2.cc \
	database.h \
	exceptions.h \
	log.h \
	phase2.h \
	statement.h \
	strmgr.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ phase2.cc

${BIN_DIR}/phase3.${OBJ_EXT} : phase3.cc \
	database.h \
	exceptions.h \
	log.h \
	phase3.h \
	phase3_html.h \
	statement.h \
	strmgr.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ phase3.cc

${BIN_DIR}/phase3_html.${OBJ_EXT} : phase3_html.cc \
	database.h \
	exceptions.h \
	log.h \
	phase3_html.h \
	statement.h \
	strmgr.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ phase3_html.cc

${BIN_DIR}/statement.${OBJ_EXT} : statement.cc \
	exceptions.h \
	log.h \
	statement.h \
	strmgr.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ statement.cc

${BIN_DIR}/strmgr.${OBJ_EXT} : strmgr.cc \
	exceptions.h \
	strmgr.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ strmgr.cc

${BIN_DIR}/switches.${OBJ_EXT} : switches.cc \
	exceptions.h \
	log.h \
	switches.h
	@echo "================================================"
	@echo "Compiling $@"
	${CXX} ${CXX_FLAGS} ${CXX_OUT}$@ switches.cc

