// Verify fix for issue 0162 (doxygen style single comments).
// Verify fix for issue 0163 (doxygen style @endlink directive).
// Verify fix for issue 0164 (doxygen style @file comment).

int a1; //!< Variable a1.
int a2; ///< Variable a2.
int a3; /*!< Variable a3. */
int a4; /**< Variable a4. */

/**
 * Issue 163:
 * Verify that the doxygen @endlink directive is ignored:
 * prefix1 @link a1 A1 @endlink ,
 * perfix2 @link a1 @endlink ,
 * @link a2 A2 @endlink
 *,
 * @link a2 @endlink
 *,
 * @link a3
 *,
 * @link a4 
 * here.
 */
int a5;

/**
 * @file foo
 * This comment should be completely ignored.
 */
int a6;

//{
// @file foo
// This comment should be completely ignored.
//}
int a7;
